struts validator的注意事项
struts 与commons validator版本搭配不当的时候会导致js出错(生成的js里没有retrieveFormName方法),
或者是validator-rules里的arg里的 resource="true" bundle="someRes"不起作用
(比如如下配置
——————————-
struts-config里
  <message-resources parameter="ApplicationResources" />
  <message-resources key="testrs" parameter="com.lizongbo.localstring.TestRs" />

validator.xml里
    <form name="EditActionForm">
    <field property="rowid" depends="required">
      <arg key="EditActionForm.rowid" position="0" resource="true"/>
    </field>
    <field property="msgid" depends="required">
      <arg key="msgid" position="0" resource="true" bundle="testrs"/>
    </field>
    </form>
ApplicationResources.properties中
EditActionForm.rowid = 测试id
com/lizongbo/localstring/TestRs.properties中
msgid =  消息编号
——————————–
这个时候rowid的资源捆绑会成功,而msgid的资源捆绑确是无效的,
jb2006自带在struts1.2.4版本上会导致国际化版本校验捆绑不了资源。),
经过试验,成功解决这两个问题的版本搭配是使用struts1.2.8版本和commons validator 1.2.0版本结合。

2.正确的操作如下:
a.下载
struts1.2.8
http://www.eu.apache.org/dist/struts/binaries/struts-1.2.8-bin.zip
http://www.eu.apache.org/dist/struts/source/struts-1.2.8-src.zip

commons validator1.2
http://www.eu.apache.org/dist/jakarta/commons/validator/binaries/commons-validator-1.2.0.zip
http://www.eu.apache.org/dist/jakarta/commons/validator/source/commons-validator-1.2.0-src.zip

用commons-validator-1.2.0.zip\commons-validator-1.2.0\commons-validator-1.2.0.jar
替换D:\Borland\JBuilder2006\thirdparty\jakarta-struts-1.2-lib\commons-validator.jar,
用struts-1.2.8-bin.zip\struts-1.2.8-bin\lib\struts.jar替换
D:\Borland\JBuilder2006\thirdparty\jakarta-struts-1.2-lib\struts.jar,
用struts-1.2.8-bin.zip\struts-1.2.8-bin\lib\validator-rules.xml替换
D:\Borland\JBuilder2006\thirdparty\jakarta-struts-1.2-lib\validator-rules.xml

编辑D:\Borland\JBuilder2006\thirdparty\jakarta-struts-1.2-lib\validation.xml,修改后内容如下:
(dtd使用1.2.0版本的)
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE form-validation PUBLIC
     "-//Apache Software Foundation//DTD Commons Validator Rules Configuration 1.2.0//EN"
     "http://jakarta.apache.org/commons/dtds/validator_1_2_0.dtd">
<form-validation>
</form-validation>
(下面这步好像可以不用,如果没有发现validator_1_2_0.dtd,则进行这个操作)
下载http://jakarta.apache.org/commons/dtds/validator_1_2_0.dtd并将它保存到
D:\Borland\JBuilder2006\lib\dtd\apache\下面。

(顺便建议把D:\Borland\JBuilder2006\thirdparty\jakarta-struts-1.2-lib\下的commons*.jar全部升级为当前最新的版本)
至此,在jbuilder里新建的使用struts1.2的webapp都可以正常的使用validator了。


注意:struts的validator对消息的国际化是根据formset来识别的
因此假设需要支持zh_CN和en以及zh_HK。
因此需要如下配置,(formset内的form设置可以复制多份即可)
validator-test.xml
—————————
<form-validation>
  <formset><!–这个是默认的必须的–>
  </formset>
  <formset language="zh"><!–这个是zh的–>
  </formset>
  <formset language="en"><!–这个是en的–>
  </formset>
  <formset language="zh" country="CN"><!–这个是zh_CN的–>
  </formset>
  <formset language="zh" country="HK"><!–这个是zh_HK的–>
  </formset>
</form-validation>

同时注意,如果指定了一个Locale,这个locale是当然web应用没有支持的语言,
比如用户选择了locale为fr,此时服务器会使用一个默认的,
但是这个默认的不是我们所认为对应的ApplicationResources不带任何后缀的资源。
而好像是request.getLocale得到的,或者是jdk自己的。
(我的测试情况如下,formset里只支持默认,zh,zh_CN,zh_HK,当我选择locale为en_GB的时候
,页面返回的消息是zh版本的,而我的浏览器是zh的,jdk也是zh的,我没有去看struts的src了,
因此无从判定struts到底依据的是哪一个)

webapp里使用struts validator。
FormBean里, import org.apache.struts.validator.ValidatorForm; 继承extends ValidatorForm 。

用最新版本的commons validator ,把js单独提取为:commonsvalidator.js,然后使用下面这样的代码:
jsp里
显示出错信息:
<logic:messagesPresent>
  <bean:message key="errors.header"/>
  <ul>
  <html:messages id="error">
     <li><bean:write name="error"/></li>
  </html:messages>
  </ul><hr>
</logic:messagesPresent>

引用js
<script type="text/javascript" language="Javascript1.1" src="<%=request.getContextPath()%>/commonsvalidator.js"/>
<html:javascript formName="myActionForm" dynamicJavascript="true" staticJavascript="false"/>
html form里 <html:form  onsubmit="return validateMyActionForm(this);"(注意大小写变化:myActionForm–>validateMyActionForm);


2条评论

  1. 你的文章太好了,及时雨啊

  2. 这是我的邮箱,交个朋友

    xm3621949@163.com

发表评论

评论也有版权!